GNU/Linux Administration - Support #980

Install MagicMirror on Debian
06/21/2025 10:11 PM - Daniel Curtis

Status: Resolved Start date: 06/21/2025
Priority: Normal Due date:

Assignee: Daniel Curtis % Done: 100%
Category: Node.js Estimated time: 1.00 hour
Target version: Debian Spent time: 0.00 hour
Description

This is a guide for installing MagicMirror with Debian Bookworm on a Raspberry Pi 2

Prepare the Environment

o Make sure everything is up to date:
sudo apt update && sudo apt upgrade
e [nstall nodejs repo:

curl -fsSL https://deb.nodesource.com/setup_22.x —-o nodesource_setup.sh
sudo bash nodesource_setup.sh

e |nstall required dependencies:

sudo apt install wayfire seatd xdg-user-dirs git nano openssl ca-certificates wget gnupg libgt
k-3-0 libxll-xcb-dev libnss3-dev libxssl libxtst6 libasound2 libdrm2 libgbml fonts-arphic-umin
g procps arp-scan libatkl.0-0 libraspberrypi-bin libllvml4 libgll-mesa-dri libglapi-mesa libse
nsors5 libdrm-radeonl libelfl libdrm-amdgpul libdrm-nouveau2 libgpiod-dev nodeijs

e Edit cmdline.txt :

sudo nano /boot/firmware/cmdline.txt

¢ Add wayland=on to the command line options:

console=serial0,115200 console=ttyl root=PARTUUID=ef31a647-01 rootfstype=ext4d fsck.repair=yes
wayland=on rootwait cfg80211.ieee80211_regdom=US

* Create the magicmirror user and add it to the video group:

sudo adduser —--uid 1001 -ingroup users —--shell /bin/bash —--comment "magicmirror" mm
sudo usermod —-aG video mm

e Create a wayfire service file:

sudo nano /etc/systemd/system/wayfire.service

o And add the following:
[Unit]
Description=Wayfire Wayland Compositor
After=rc-local.service

[Service]

User=mm

Type=simple

ExecStart=/usr/bin/wayfire

Restart=on-failure
Environment=XDG_RUNTIME_DIR=/var/run/user/1001

[Install]
WantedBy=multi-user.target

® Reload systemd and enable the service at boot:

sudo systemctl daemon-reload
sudo systemctl enable wayfire

Install MagicMirror

e Switch to the magicmirror user:
sudo su — mm
e Add XDG_RUNTIME_DIR to .bashrc:
echo "export XDG_RUNTIME_DIR=/run/user/1001" >> ~/.bashrc
¢ Clone the MagicMirror repository:
git clone https://github.com/MagicMirrorOrg/MagicMirror
¢ [nstall the application:

cd MagicMirror
npm run install-mm

® Create the config file:

cp config/config.js.sample config/config.js

Autostart MagicMirror

* Create a launch script:

nano /home/mm/launch-mm.sh

o And add the following:

#!/bin/bash
cd /home/mm/MagicMirror
npm run start:wayland

o Don't forget to make it executable:

chmod +x /home/mm/launch-mm.sh

e Create a wayfire config

nano /home/mm/.config/wayfire.ini

o And add the following:

[core]
plugins = autostart

[autostart]
boot = /home/mm/launch-mm.sh

Resources

https://docs.magicmirror.builders/getting-started/installation.html
https://github.com/sdetweil/MagicMirror_scripts/blob/master/raspberry.sh
https://gitlab.com/khassel/magicmirror/-/raw/master/build/Dockerfile-debian?ref type=heads
https://gist.github.com/seffs/2395ca640d6d8d8228a19a999541821 1
https://www.raspberrypi.com/documentation/computers/configuration.html#wayland

e https://utdream.org/xdg_runtime_dir-is-invalid-or-not-set-on-raspberry-pi-5/

e https:/forums.raspberrypi.com/viewtopic.php?t=376273

e o o o

History

#1 - 06/22/2025 04:51 PM - Daniel Curtis
- Estimated time set to 1.00 h

- % Done changed from 0 to 90

- Status changed from New to In Progress

- Description updated

#2 - 06/22/2025 04:56 PM - Daniel Curtis

- Description updated

#3 - 06/22/2025 09:53 PM - Daniel Curtis
- % Done changed from 90 to 100
- Status changed from In Progress to Resolved

- Description updated
